Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.workplace.wcm.api.extensions.url
Interface ContentUrlGenerationRequest

    public interface ContentUrlGenerationRequest

Request object of the content URL generation filter chain that contains various parameters that might be required to generate a URL for a given content. The request also contains methods to share attributes between content URL generation filters.

Since:
  8.0
See Also:
  `ContentUrlGenerationFilter`, `ContentUrlGenerationFilterChain`
Note:

  This interface is designed to be implemented by clients.

Method Summary
`boolean` | `escapeXml()` Should characters reserved in XML be escaped in the URL generated.
`java.lang.Object` | `getAttribute(java.lang.String name)` Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
`java.util.Iterator<java.lang.String>` | `getAttributeNames()` Returns an `Iterator` containing the names of the attributes available to this request.
`java.lang.String` | `getContentPath(boolean encode)` Get the name path of the content the URL should be generated for
`TargetPageConfig` | `getDynamicTargetPageOverride()` Get the target page override that defines what should page be used to render the content the URL is generated for.
`java.util.Map<java.lang.String,java.lang.String[]>` | `getParameters()` Get additional parameters.
`PortletContextSharingConfig` | `getPortletContextSharingConfig()` The portlet context sharing configuration that determines how the rendering portlez receives and broadcast links with other portlets.
`RenderRequest` | `getPortletRenderRequest()` Get the portlet render request
`RenderResponse` | `getPortletRenderResponse()` Get the portlet render response
`java.lang.String` | `getPresentationTemplateOverride()` Get the name path of the presentation template that should be used to render the content the URL is generated for.
`RenderingContext` | `getRenderingContext()` Get the rendering context of the rendered content.
`void` | `removeAttribute(java.lang.String name)` Removes an attribute from this request.
`void` | `setAttribute(java.lang.String name, java.lang.Object o)` Stores an attribute in this request.

Method Detail

### getContentPath

    java.lang.String getContentPath(boolean encode)

  Get the name path of the content the URL should be generated for

  Parameters:
    `encode` - Specify if the returned path should be URL encoded
  Returns:
    The path of the content constructed from the names of the items in the content hierarchy or `null` e.g. for URLs that only contain a prefix

### getPresentationTemplateOverride

    java.lang.String getPresentationTemplateOverride()

  Get the name path of the presentation template that should be used to render the content the URL is generated for.

  Returns:
    The presentation template path or `null` if the default presentation should be used

### getDynamicTargetPageOverride

    TargetPageConfig getDynamicTargetPageOverride()

  Get the target page override that defines what should page be used to render the content the URL is generated for. This method only returns the target page specification that was set on a WCM tag e.g. the portalTarget attribute on the [UrlCmpnt] tag. This method does not return the target page configuration from the portlet context sharing configuration. To get the portlet configuration use `getPortletContextSharingConfig()`.

  Returns:
    The target page override or `null`

### getPortletRenderRequest

    RenderRequest getPortletRenderRequest()

  Get the portlet render request

  Returns:
    The request never `null`

### getPortletRenderResponse

    RenderResponse getPortletRenderResponse()

  Get the portlet render response

  Returns:
    The response never `null`

### getPortletContextSharingConfig

    PortletContextSharingConfig getPortletContextSharingConfig()

  The portlet context sharing configuration that determines how the rendering portlez receives and broadcast links with other portlets. This determines whether rendering portlets are aware of the state or context of other portlets.

  Returns:
    The portlet context sharing context never `null`

### getRenderingContext

    RenderingContext getRenderingContext()

  Get the rendering context of the rendered content. The rendered content is the content that contains the references to the content items the URL should be generated for.

  Returns:
    The rendering context never `null`

### getParameters

    java.util.Map<java.lang.String,java.lang.String[]> getParameters()

  Get additional parameters. The map is probably unmodifiable and should not be modified even if it happens to be modifiable. This map also contains all attributes from the [UrlCmpnt] tag if the tag was used to reference the content the URL is generated for.

  Returns:
    Map of type containing additional context parameters. The map might be empty but never `null`

### escapeXml

    boolean escapeXml()

  Should characters reserved in XML be escaped in the URL generated.

  Returns:
    `true` if characters reserved in XML should be escaped in the URL generated.

### setAttribute

    void setAttribute(java.lang.String name,
                      java.lang.Object o)

  Stores an attribute in this request. If the value passed into this method is `null`, the effect is the same as calling `removeAttribute(java.lang.String)`.

  Parameters:
    `name` - a `String` specifying the name of the attribute
    `o` - the `Object` to be stored
  Throws:
    `java.lang.IllegalArgumentException` - if name is `null`.

### getAttribute

    java.lang.Object getAttribute(java.lang.String name)

  Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

  Parameters:
    `name` - a `String` specifying the name of the attribute
  Returns:
    an `Object` containing the value of the attribute, or `null` if the attribute does not exist.
  Throws:
    `java.lang.IllegalArgumentException` - if name is `null`.

### removeAttribute

    void removeAttribute(java.lang.String name)

  Removes an attribute from this request. This method is not generally needed, as attributes only persist as long as the request is being handled.

  Parameters:
    `name` - a `String` specifying the name of the attribute to be removed
  Throws:
    `java.lang.IllegalArgumentException` - if name is `null`.

### getAttributeNames

    java.util.Iterator<java.lang.String> getAttributeNames()

  Returns an `Iterator` containing the names of the attributes available to this request. This method returns an empty `Iterator` if the request has no attributes available to it.

  Returns:
    an `Iterator` of strings containing the names of the request attributes, or an empty `Iterator` if the request has no attributes available to it.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD